import Taro from "@tarojs/taro-h5";
import Nerv from "nervjs";
import classNames from 'classnames';
import PropTypes from 'prop-types';
import { View } from '@tarojs/components';
import { idxList } from 'number-magic';
import BaseComponent from '../BaseComponent';
import { envInfo } from '../../common/utils';
export default class MieHx extends BaseComponent {
  constructor(props) {
    super(props);

    this.state = {
      isWEB: envInfo.isWEB
    };
  }
  render() {
    const { size } = this.props;
    const hxClassName = `mie-hx mie-hx--${size}`;
    if (this.state.isWEB) {
      const WebTag = `h${size}`;
      return <WebTag className={classNames(hxClassName, this.props.className)} style={this.props.customStyle} onClick={this.onClick}>
          {this.props.children}
        </WebTag>;
    }
    return <View className={classNames(hxClassName, this.props.className)} style={this.props.customStyle} onClick={this.onClick}>
        {this.props.children}
      </View>;
  }
  onClick = event => {
    this.props.onClick && this.props.onClick(event);
  };
}
MieHx.defaultProps = {
  size: 3,
  onClick: () => {},
  customStyle: {}
};
MieHx.propTypes = {
  size: PropTypes.oneOf(idxList(6, 1)),
  onClick: PropTypes.func,
  className: PropTypes.any,
  customStyle: PropTypes.object
};