import Taro from "@tarojs/taro-h5";
import Nerv from "nervjs";
import classNames from "classnames";
import PropTypes from "prop-types";
import { View } from "@tarojs/components";
import BaseComponent from "../BaseComponent";
import { envInfo } from "../../common/utils";
export default class MieRichText extends BaseComponent {
  constructor(props) {
    super(props);

    this.state = {
      isWEB: envInfo.isWEB
    };
  }
  render() {
    const { className, customStyle, html, styleText } = this.props;
    let fullHtml = html;
    if (styleText) {
      const st = `<style>${styleText}</style>`;
      fullHtml = `${st}${html}`;
    }
    if (this.state.isWEB) {
      return <div className={classNames("mie-rich-text", className)}
      // @ts-ignore
      style={customStyle} dangerouslySetInnerHTML={{ __html: fullHtml }}></div>;
    }
    return <View className={classNames("mie-rich-text", className)} style={customStyle}>
        
        <parser html={fullHtml} linkpress={this.handleLinkpress}></parser>
      </View>;
  }
  config = {
    usingComponents: {
      parser: "./parser/parser"
    }
  };
}
MieRichText.defaultProps = {
  html: "",
  customStyle: {},
  styleText: `
      img {
        max-width: 100%;
      }
    `
};
MieRichText.propTypes = {
  html: PropTypes.string,
  styleText: PropTypes.string
};